# IRPCSearch.GetFolderContentsOfPinboard

Location: [gRPC API](https://developer.m-files.com/APIs/gRPC-API/index.md) > [Vault API](https://developer.m-files.com/APIs/gRPC-API/vault/index.md) > [Search](https://developer.m-files.com/APIs/gRPC-API/Reference/MFiles.IRPCSearch/index.md)

HTML version: https://developer.m-files.com/APIs/gRPC-API/Reference/MFiles.IRPCSearch/GetFolderContentsOfPinboard/

Badges: `Vault API / core` `write` `session or assertion` `returns metadata structure version`

Gets the contents of the Pinboard items.

- **Service:** [Search](https://developer.m-files.com/APIs/gRPC-API/Reference/MFiles.IRPCSearch/index.md) `MFiles.IRPCSearch`
- **gRPC method:** `/MFiles.IRPCSearch/GetFolderContentsOfPinboard`
- **HTTP (mf-http-grpc):** `POST /grpc/v1/get-folder-contents-of-pinboard`
- **Request:** [`GetFolderContentsOfPinboardRequest`](https://developer.m-files.com/APIs/gRPC-API/Reference/MFiles.IRPCSearch/GetFolderContentsOfPinboard/index.md#request)
- **Response:** [`GetFolderContentsOfPinboardResponse`](https://developer.m-files.com/APIs/gRPC-API/Reference/MFiles.IRPCSearch/GetFolderContentsOfPinboard/index.md#response)
- **Book and level:** Vault API, core
- **Kind:** write
- **Session:** Required: a session (mfiles-session-id-bin metadata) or a session assertion (x-mf-session-assertion metadata).
- **Idempotent:** no
- **Returns metadata structure version:** yes (in the mfiles-metadata-version-bin trailer)
- **Streaming:** none (unary)

<a id="remarks"></a>

## Remarks

Used by the M-Files clients to show the caller's pinned items.

<a id="request"></a>

## Request: GetFolderContentsOfPinboardRequest

> Nested message fields are expanded to depth 3; follow a type link for deeper levels and for the type's own page.

| Field | Type | Description |
|---|---|---|
| `max_results` | `uint32` | Requested max results. If this is 0, it should be ignored. |
| `include_parent` | `bool` | True if parent location of the property and traditional folders to be included in the result. |

<a id="response"></a>

## Response: GetFolderContentsOfPinboardResponse

> Nested message fields are expanded to depth 3; follow a type link for deeper levels and for the type's own page.

| Field | Type | Description |
|---|---|---|
| `view_folders_with_parent_location[]` | repeated [`ViewWithParentLocation`](https://developer.m-files.com/APIs/gRPC-API/Reference/Messages/MFiles.ViewWithParentLocation/index.md) | Resulting views. |
| `view_folders_with_parent_location[].parent_location[]` | repeated [`Folder`](https://developer.m-files.com/APIs/gRPC-API/Reference/Messages/MFiles.Folder/index.md) | The location of the view folder. |
| `view_folders_with_parent_location[].parent_location[].type` | [`FolderType`](https://developer.m-files.com/APIs/gRPC-API/Reference/Enums/MFiles.FolderType/index.md) | The type of the folder, for example `FOLDER_TYPE_VIEW_FOLDER` or `FOLDER_TYPE_PROPERTY_FOLDER`. Values: `FOLDER_TYPE_UNKNOWN` (0), `FOLDER_TYPE_ANY_FOLDER` (1), `FOLDER_TYPE_VIEW_FOLDER` (2), `FOLDER_TYPE_PROPERTY_FOLDER` (3), `FOLDER_TYPE_TRADITIONAL_FOLDER` (4), `FOLDER_TYPE_SEARCH_FOLDER` (5), `FOLDER_TYPE_EXTERNAL_VIEW_FOLDER` (6). |
| `view_folders_with_parent_location[].parent_location[].data` | [`FolderInfoUnion`](https://developer.m-files.com/APIs/gRPC-API/Reference/Messages/MFiles.FolderInfoUnion/index.md) | Additional folder type -specific information as a union. |
| `view_folders_with_parent_location[].value` | [`View`](https://developer.m-files.com/APIs/gRPC-API/Reference/Messages/MFiles.View/index.md) | Resulting the view. |
| `view_folders_with_parent_location[].value.id` | `int32` | The ID of the view. |
| `view_folders_with_parent_location[].value.type` | [`ViewType`](https://developer.m-files.com/APIs/gRPC-API/Reference/Enums/MFiles.ViewType/index.md) | The type of the view. Values: `VIEW_TYPE_SHOW_OBJECTS` (0), `VIEW_TYPE_FILTER_ONLY` (1). |
| `view_folders_with_parent_location[].value.name` | `string` | The name of the view. |
| `view_folders_with_parent_location[].value.is_common` | `bool` | Tells if the view is admin-defined (common) or user-defined. |
| `view_folders_with_parent_location[].value.is_visible` | `bool` | Tells if the view is visible. |
| `view_folders_with_parent_location[].value.location` | [`ViewLocation`](https://developer.m-files.com/APIs/gRPC-API/Reference/Messages/MFiles.ViewLocation/index.md) | The location of the view. Valid only if bHasParent is true. |
| `view_folders_with_parent_location[].value.content_definition` | [`SearchDef`](https://developer.m-files.com/APIs/gRPC-API/Reference/Messages/MFiles.SearchDef/index.md) | The search definition that contains the view levels and search conditions of the view. |
| `view_folders_with_parent_location[].value.acl` | [`AccessControlList`](https://developer.m-files.com/APIs/gRPC-API/Reference/Messages/MFiles.AccessControlList/index.md) | Permissions. |
| `view_folders_with_parent_location[].value.flags_obsolete` | `uint32` | Bit flags that provide additional information on the view. |
| `view_folders_with_parent_location[].value.options` | [`VIEWFLAGS`](https://developer.m-files.com/APIs/gRPC-API/Reference/Messages/MFiles.VIEWFLAGS/index.md) | Bit flags that provide additional information on the view. |
| `view_folders_with_parent_location[].value.guid` | `string` | GUID for the view. |
| `view_folders_with_parent_location[].value.view_visualization` | [`ViewVisualization`](https://developer.m-files.com/APIs/gRPC-API/Reference/Messages/MFiles.ViewVisualization/index.md) | View visualization information. |
| `view_folders_with_parent_location[].pinned_item_id` | `string` | The pinned item id is the guid key referencing this item in pinboard. |
| `property_folders_with_parent_location[]` | repeated [`PropertyFolderWithParent`](https://developer.m-files.com/APIs/gRPC-API/Reference/Messages/MFiles.PropertyFolderWithParent/index.md) | Resulting property folders. |
| `property_folders_with_parent_location[].parent_location[]` | repeated [`Folder`](https://developer.m-files.com/APIs/gRPC-API/Reference/Messages/MFiles.Folder/index.md) | The location of the parent folders. Field with fid( 2 ) is reserved for legacy reasons and must not be re-used. |
| `property_folders_with_parent_location[].parent_location[].type` | [`FolderType`](https://developer.m-files.com/APIs/gRPC-API/Reference/Enums/MFiles.FolderType/index.md) | The type of the folder, for example `FOLDER_TYPE_VIEW_FOLDER` or `FOLDER_TYPE_PROPERTY_FOLDER`. Values: `FOLDER_TYPE_UNKNOWN` (0), `FOLDER_TYPE_ANY_FOLDER` (1), `FOLDER_TYPE_VIEW_FOLDER` (2), `FOLDER_TYPE_PROPERTY_FOLDER` (3), `FOLDER_TYPE_TRADITIONAL_FOLDER` (4), `FOLDER_TYPE_SEARCH_FOLDER` (5), `FOLDER_TYPE_EXTERNAL_VIEW_FOLDER` (6). |
| `property_folders_with_parent_location[].parent_location[].data` | [`FolderInfoUnion`](https://developer.m-files.com/APIs/gRPC-API/Reference/Messages/MFiles.FolderInfoUnion/index.md) | Additional folder type -specific information as a union. |
| `property_folders_with_parent_location[].value` | [`TypedValue`](https://developer.m-files.com/APIs/gRPC-API/Reference/Messages/MFiles.TypedValue/index.md) | The value of the property. |
| `property_folders_with_parent_location[].value.is_null_value` | `bool` | True if the value is empty. `data` is then unset. |
| `property_folders_with_parent_location[].value.type` | [`Datatype`](https://developer.m-files.com/APIs/gRPC-API/Reference/Enums/MFiles.Datatype/index.md) | The data type of the value. |
| `property_folders_with_parent_location[].value.data` | [`TypedValueUnion`](https://developer.m-files.com/APIs/gRPC-API/Reference/Messages/MFiles.TypedValueUnion/index.md) | The value, in the member that matches `type`. Unset for an empty value. |
| `property_folders_with_parent_location[].pinned_item_id` | `string` | The pinned item id is the guid key referencing this item in pinboard. |
| `property_folders_with_parent_location[].last_parent_view` | [`View`](https://developer.m-files.com/APIs/gRPC-API/Reference/Messages/MFiles.View/index.md) | The last view and search conditions from the parent folder. |
| `property_folders_with_parent_location[].last_parent_view.id` | `int32` | The ID of the view. |
| `property_folders_with_parent_location[].last_parent_view.type` | [`ViewType`](https://developer.m-files.com/APIs/gRPC-API/Reference/Enums/MFiles.ViewType/index.md) | The type of the view. Values: `VIEW_TYPE_SHOW_OBJECTS` (0), `VIEW_TYPE_FILTER_ONLY` (1). |
| `property_folders_with_parent_location[].last_parent_view.name` | `string` | The name of the view. |
| `property_folders_with_parent_location[].last_parent_view.is_common` | `bool` | Tells if the view is admin-defined (common) or user-defined. |
| `property_folders_with_parent_location[].last_parent_view.is_visible` | `bool` | Tells if the view is visible. |
| `property_folders_with_parent_location[].last_parent_view.location` | [`ViewLocation`](https://developer.m-files.com/APIs/gRPC-API/Reference/Messages/MFiles.ViewLocation/index.md) | The location of the view. Valid only if bHasParent is true. |
| `property_folders_with_parent_location[].last_parent_view.content_definition` | [`SearchDef`](https://developer.m-files.com/APIs/gRPC-API/Reference/Messages/MFiles.SearchDef/index.md) | The search definition that contains the view levels and search conditions of the view. |
| `property_folders_with_parent_location[].last_parent_view.acl` | [`AccessControlList`](https://developer.m-files.com/APIs/gRPC-API/Reference/Messages/MFiles.AccessControlList/index.md) | Permissions. |
| `property_folders_with_parent_location[].last_parent_view.flags_obsolete` | `uint32` | Bit flags that provide additional information on the view. |
| `property_folders_with_parent_location[].last_parent_view.options` | [`VIEWFLAGS`](https://developer.m-files.com/APIs/gRPC-API/Reference/Messages/MFiles.VIEWFLAGS/index.md) | Bit flags that provide additional information on the view. |
| `property_folders_with_parent_location[].last_parent_view.guid` | `string` | GUID for the view. |
| `property_folders_with_parent_location[].last_parent_view.view_visualization` | [`ViewVisualization`](https://developer.m-files.com/APIs/gRPC-API/Reference/Messages/MFiles.ViewVisualization/index.md) | View visualization information. |
| `traditional_folders_with_parent_location[]` | repeated [`TraditionalFolderWithParent`](https://developer.m-files.com/APIs/gRPC-API/Reference/Messages/MFiles.TraditionalFolderWithParent/index.md) | Resulting traditional folders. |
| `traditional_folders_with_parent_location[].parent_location[]` | repeated [`Folder`](https://developer.m-files.com/APIs/gRPC-API/Reference/Messages/MFiles.Folder/index.md) | The location of the traditional folder. |
| `traditional_folders_with_parent_location[].parent_location[].type` | [`FolderType`](https://developer.m-files.com/APIs/gRPC-API/Reference/Enums/MFiles.FolderType/index.md) | The type of the folder, for example `FOLDER_TYPE_VIEW_FOLDER` or `FOLDER_TYPE_PROPERTY_FOLDER`. Values: `FOLDER_TYPE_UNKNOWN` (0), `FOLDER_TYPE_ANY_FOLDER` (1), `FOLDER_TYPE_VIEW_FOLDER` (2), `FOLDER_TYPE_PROPERTY_FOLDER` (3), `FOLDER_TYPE_TRADITIONAL_FOLDER` (4), `FOLDER_TYPE_SEARCH_FOLDER` (5), `FOLDER_TYPE_EXTERNAL_VIEW_FOLDER` (6). |
| `traditional_folders_with_parent_location[].parent_location[].data` | [`FolderInfoUnion`](https://developer.m-files.com/APIs/gRPC-API/Reference/Messages/MFiles.FolderInfoUnion/index.md) | Additional folder type -specific information as a union. |
| `traditional_folders_with_parent_location[].value` | [`Lookup`](https://developer.m-files.com/APIs/gRPC-API/Reference/Messages/MFiles.Lookup/index.md) | Traditional folders. This contains inserted or updated traditional folders if this struct represents a delta, otherwise it contains just a "normal" array of traditional folders. |
| `traditional_folders_with_parent_location[].value.value_list_item_info` | [`ItemInfo`](https://developer.m-files.com/APIs/gRPC-API/Reference/Messages/MFiles.ItemInfo/index.md) | The selected item. Only `obj_id` is needed when setting a value. |
| `traditional_folders_with_parent_location[].value.version` | [`ObjVerVersion`](https://developer.m-files.com/APIs/gRPC-API/Reference/Messages/MFiles.ObjVerVersion/index.md) | The version of the selected object. The server returns `OBJ_VER_VERSION_TYPE_LATEST` (-1), meaning the latest version. |
| `traditional_folders_with_parent_location[].pinned_item_id` | `string` | The pinned item id is the guid key referencing this item in pinboard. |
| `objects[]` | repeated [`PinnedObject`](https://developer.m-files.com/APIs/gRPC-API/Reference/Messages/MFiles.PinnedObject/index.md) | Resulting objects. |
| `objects[].search_results_item` | [`SearchResultsItem`](https://developer.m-files.com/APIs/gRPC-API/Reference/Messages/MFiles.SearchResultsItem/index.md) | The search result item. |
| `objects[].search_results_item.object` | [`ObjectVersionEx`](https://developer.m-files.com/APIs/gRPC-API/Reference/Messages/MFiles.ObjectVersionEx/index.md) | The object and the found version: object ID, version, title, class, files and status. Property values are not included. |
| `objects[].search_results_item.score` | `int32` | The relevance score of the result. Higher is more relevant. |
| `objects[].search_results_item.chunk` | `string` | For an Aino search, the passage of text that matched. Empty for other searches. |
| `objects[].pinned_item_id` | `string` | The pinned item id is the guid key referencing this item in pinboard. |
| `external_folders_with_parent_location[]` | repeated [`ExternalViewWithParentLocation`](https://developer.m-files.com/APIs/gRPC-API/Reference/Messages/MFiles.ExternalViewWithParentLocation/index.md) | External views. ( Represented by ExternalViewWithParentLocation struct 0 |
| `external_folders_with_parent_location[].parent_location[]` | repeated [`Folder`](https://developer.m-files.com/APIs/gRPC-API/Reference/Messages/MFiles.Folder/index.md) | The location of the External view. |
| `external_folders_with_parent_location[].parent_location[].type` | [`FolderType`](https://developer.m-files.com/APIs/gRPC-API/Reference/Enums/MFiles.FolderType/index.md) | The type of the folder, for example `FOLDER_TYPE_VIEW_FOLDER` or `FOLDER_TYPE_PROPERTY_FOLDER`. Values: `FOLDER_TYPE_UNKNOWN` (0), `FOLDER_TYPE_ANY_FOLDER` (1), `FOLDER_TYPE_VIEW_FOLDER` (2), `FOLDER_TYPE_PROPERTY_FOLDER` (3), `FOLDER_TYPE_TRADITIONAL_FOLDER` (4), `FOLDER_TYPE_SEARCH_FOLDER` (5), `FOLDER_TYPE_EXTERNAL_VIEW_FOLDER` (6). |
| `external_folders_with_parent_location[].parent_location[].data` | [`FolderInfoUnion`](https://developer.m-files.com/APIs/gRPC-API/Reference/Messages/MFiles.FolderInfoUnion/index.md) | Additional folder type -specific information as a union. |
| `external_folders_with_parent_location[].value` | [`ExternalView`](https://developer.m-files.com/APIs/gRPC-API/Reference/Messages/MFiles.ExternalView/index.md) | Resulting the Exterrnal view. |
| `external_folders_with_parent_location[].value.id` | [`ExternalRepositoryID`](https://developer.m-files.com/APIs/gRPC-API/Reference/Messages/MFiles.ExternalRepositoryID/index.md) | The view ID in external repository. |
| `external_folders_with_parent_location[].value.display_name` | `string` | The name of the view. |
| `external_folders_with_parent_location[].value.external_repository_icon_id` | `string` | The icon ID. |
| `external_folders_with_parent_location[].value.parent_id` | [`ExternalRepositoryID`](https://developer.m-files.com/APIs/gRPC-API/Reference/Messages/MFiles.ExternalRepositoryID/index.md) | The view's parent ID in external repository. May be uninitialized if the external view does not have a parent. |
| `external_folders_with_parent_location[].value.object_data` | [`ObjectVersionExWP`](https://developer.m-files.com/APIs/gRPC-API/Reference/Messages/MFiles.ObjectVersionExWP/index.md) | If not null, the object representation of the folder. |
| `external_folders_with_parent_location[].value.folder_capabilities` | [`FOLDERCAPABILITYFLAGS`](https://developer.m-files.com/APIs/gRPC-API/Reference/Messages/MFiles.FOLDERCAPABILITYFLAGS/index.md) | Bit flags that provide information on the folder capabilities. |
| `external_folders_with_parent_location[].value.acl` | [`AccessControlList`](https://developer.m-files.com/APIs/gRPC-API/Reference/Messages/MFiles.AccessControlList/index.md) | If set, ACL. |
| `external_folders_with_parent_location[].pinned_item_id` | `string` | The pinned item id is the guid key referencing this item in pinboard. |
| `more_property_folders` | `bool` | Are there more property folders? Currently it is false. It will be implemented in future. |
| `more_objects` | `bool` | Are there more objects? Currently it is false. It will be implemented in future. |
| `more_external_folders` | `bool` | Are there more external view folders? Currently it is false. It will be implemented in future. |
| `limited_item_groups[]` | repeated `int32` | Receives the list of item group identifications IDs the results of which were limited. The group identification ID depends on how the search results were grouped. E.g. object type ID.Currently it is not carrying any data. It will be implemented in future. |
| `search_output_info` | [`SearchOutputInfo`](https://developer.m-files.com/APIs/gRPC-API/Reference/Messages/MFiles.SearchOutputInfo/index.md) | Additional information about the completed search operation.Currently it is not carrying any data. It will be implemented in future. |
| `search_output_info.processing_time_at_engine_in_milliseconds` | `int32` | The processing time at the search engine, in milliseconds. -1 if not known. |
| `search_output_info.processing_time_at_engine_from_mfserver_in_milliseconds` | `int32` | The processing time at the search engine, including network roundtrip from MFServer, in milliseconds. -1 if not known. |
| `search_output_info.processing_time_at_mfserver_in_milliseconds` | `int32` | The total processing time at MFServer, in milliseconds. -1 if not known. |
| `search_output_info.processing_time_at_mfserver_from_client_in_milliseconds` | `int32` | The total processing time at MFServer, including network roundtrip from the client, in milliseconds. -1 if not known. |

<a id="related"></a>

## Related methods

- [GetFolderContents](https://developer.m-files.com/APIs/gRPC-API/Reference/MFiles.IRPCSearch/GetFolderContents/index.md): Lists the contents of a view or a view level: subviews, grouping folders and objects.
